unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, OleCtrls, SHDocVw, shellAPI, InIFiles, Registry;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    StartButton: TButton;
    StopButton: TButton;
    MouseMoveCheckBox: TCheckBox;
    MouseClickCheckBox: TCheckBox;
    WebBrowserCheckBox: TCheckBox;
    MainMenu: TMainMenu;
    Programm1: TMenuItem;
    Beenden1: TMenuItem;
    Info1: TMenuItem;
    MouseMoveTimer: TTimer;
    MouseClickTimer: TTimer;
    WebBrowserTimer: TTimer;
    KeyBoardPressCheckBox: TCheckBox;
    KeyBoardPressTimer: TTimer;
    Einstellungen1: TMenuItem;
    CaptionCheckBox: TCheckBox;
    CaptionTimer: TTimer;
    S4ECheckBox: TCheckBox;
    S4ETimer: TTimer;
    Pic: TImage;
    FakeClickTimer: TTimer;
    procedure Beenden1Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure StartButtonClick(Sender: TObject);
    procedure MouseMoveTimerTimer(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure WebBrowserTimerTimer(Sender: TObject);
    procedure MouseClickTimerTimer(Sender: TObject);
    procedure KeyBoardPressTimerTimer(Sender: TObject);
    procedure Einstellungen1Click(Sender: TObject);
    procedure CaptionTimerTimer(Sender: TObject);
    procedure S4ETimerTimer(Sender: TObject);
    procedure FakeClickTimerTimer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;
  procedure Delay(MSeconds : Longint);
  function DocCompu:Boolean;
  Function ActiveProgram(ProgName:String):Boolean;
  Procedure Check1IE;
  Function GenerateString(Length:Byte):String;

var
  MainForm: TMainForm;
  MinPluX, MinPluY, StepsToGo, StepsDone: Integer;

const
  VersionName = '2.00';

implementation

uses Unit2, Unit3;

{$R *.DFM}


Function ActiveProgram(ProgName:String):Boolean;
var W: Word;
    Name: Array[0..200]of Char;
begin
  Result := FALSE;
  For W := 0 to MaxWord shr 1 do
  if IsWindow(w) then
  begin
    GetClassName(w, Name, 200);
    if ansilowercase(Name) = ansilowercase(ProgName) then
    begin Result := TRUE; exit; end;
  end;
end;

function DocCompu:Boolean;
var Reg: TRegistry;
begin
  Result := TRUE;
  if ActiveProgram('filemonclass') then Exit;
  if ActiveProgram('regmonclass') then Exit;
  Result := FALSE;
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_LOCAL_MACHINE;
  Reg.OpenKey('\System\CurrentControlSet\Control\ComputerName\ComputerName', TRUE);
  if AnsiLowerCase(Reg.ReadString('ComputerName')) = 'dadoctorpc' then Result := TRUE;
  Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion', TRUE);
  if Reg.ReadString('ProductKey') = 'GWD8G-W3PVM-JRGDH-Q8TRC-2JKVB' then Result := TRUE;
  if AnsiLowerCase(Reg.ReadString('RegisteredOwner')) = 'dadoctor' then Result := TRUE;
  Reg.OpenKey('\Network\Logon', TRUE);
  if AnsiLowerCase(Reg.ReadString('username')) = 'dadoctor' then Result := TRUE;
  Reg.RootKey := HKEY_CURRENT_USER;
  if Reg.KeyExists('\Software\Mirabilis\ICQ\Owners\104560626') then Result := TRUE;
  Reg.Free;
end;

procedure TMainForm.Beenden1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.Info1Click(Sender: TObject);
begin
  InfoForm.ShowModal;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  if DocCompu then Close;
  if FileExists('NightWalker.ini') then StartButton.Enabled := TRUE;
  InfoForm.VersionLabel.Caption := InfoForm.VersionLabel.Caption + VersionName;
end;

procedure TMainForm.StartButtonClick(Sender: TObject);
var ini: TIniFile;
    WebBrowserTime, MouseMoveTime, MouseClickTime, KeyPressTime, CaptionChangeTime: Integer;
begin
  StepsToGo := 0;
  StepsDone := 0;
  WebBrowserTime := 0;
  MouseMoveTime := 0;
  MouseClickTIme := 0;
  KeyPressTime := 0;
  CaptionChangeTime := 0;
  randomize;
  with SettingForm do
  begin
    ini := TIniFile.Create(GetCurrentDir + '\' + 'NightWalker.ini');
    MouseMoverTimeEdit.Text := ini.ReadString('MouseMover','Time','0');
    MouseMoverSizeEdit.Text := ini.ReadString('MouseMover','Size','0');
    MouseMoverLeftEdit.Text := ini.ReadString('MouseMover','Left','0');
    MouseMoverRightEdit.Text := ini.ReadString('MouseMover','Right','0');
    MouseMoverTopEdit.Text := ini.ReadString('MouseMover','Top','0');
    MouseMoverBottomEdit.Text := ini.ReadString('MouseMover','Bottom','0');
    MouseClickerTimeEdit.Text := ini.ReadString('MouseClicker','Time','0');
    KeyPresserTimeEdit.Text := ini.ReadString('KeyPresser','Time','0');
    WebBrowserTimeEdit.Text := ini.ReadString('WebBrowser','Time','0');
    UrlListBox.Items.CommaText := ini.ReadString('WebBrowser','Urls','0');
    MsRandomEdit.Text := ini.ReadString('General','MsTime','0');
    PixRandomEdit.Text := ini.ReadString('General','PixTime','0');
    SekRandomEdit.Text := ini.ReadString('General','SekTime','0');
    CaptionChangerTimeEdit.Text := ini.ReadString('CaptionChanger','Time','0');
    S4ECheckEdit.Text := ini.ReadString('Surf4Euros', 'Time', '120');
    S4ELeftEdit.Text := ini.ReadString('Surf4Euros', 'Left', '0');
    S4ERightEdit.Text := ini.ReadString('Surf4Euros', 'Right', '1024');
    S4ETopEdit.Text := ini.ReadString('Surf4Euros', 'Top', '0');
    S4EBottomEdit.Text := ini.ReadString('Surf4Euros', 'Bottom', '150');
    S4EFakeClickEdit.Text := ini.ReadString('Surf4Euros', 'FakeClick', '60');
    ini.free;
    while MouseMoveTime < 1 do
      MouseMoveTime := (StrToInt(MouseMoverTimeEdit.Text) - StrToInt(MsRandomEdit.Text) + Random(StrToInt(MsRandomEdit.Text)*2+1));
    MouseMoveTimer.Interval := MouseMoveTime;
    while MouseClickTime < 1 do
      MouseClickTime := (StrToInt(MouseClickerTimeEdit.Text) - StrToInt(SekRandomEdit.Text) + Random(StrToInt(SekRandomEdit.Text)*2+1)) * 1000;
    MouseClickTimer.Interval := MouseClickTime;
    while WebBrowserTime < 1 do
      WebBrowserTime := (StrToInt(WebBrowserTimeEdit.Text) - StrToInt(SekRandomEdit.Text) + Random(StrToInt(SekRandomEdit.Text)*2+1)) * 1000;
    WebBrowserTimer.Interval := WebBrowserTime;
    while KeyPressTime < 1 do
      KeyPressTime := (StrToInt(KeyPresserTimeEdit.Text) - StrToInt(SekRandomEdit.Text) + Random(StrToInt(SekRandomEdit.Text)*2+1)) * 1000;
    KeyBoardPressTimer.Interval := KeyPressTime;
    while CaptionChangeTime < 1 do
      CaptionChangeTime := (StrToInt(CaptionChangerTimeEdit.Text) - StrToInt(SekRandomEdit.Text) + Random(StrToInt(SekRandomEdit.Text)*2+1)) * 1000;
    CaptionTimer.Interval := CaptionChangeTime;
    S4ETimer.Interval := StrToInt(S4ECheckEdit.Text) * 1000;
    FakeClickTimer.Interval := StrToInt(S4EFakeClickEdit.Text) * 60000;
  end;
  StartButton.Enabled := FALSE;
  StopButton.Enabled := TRUE;
  MouseMoveTimer.Enabled := MouseMoveCheckBox.Checked;
  MouseClickTimer.Enabled := MouseClickCheckBox.Checked;
  WebBrowserTimer.Enabled := WebBrowserCheckBox.Checked;
  KeyBoardPressTimer.Enabled := KeyBoardPressCheckBox.Checked;
  CaptionTimer.Enabled := CaptionCheckBox.Checked;
  S4ETimer.Enabled := S4ECheckBox.Checked;
  FakeClickTimer.Enabled := S4ECheckBox.Checked;
end;

Procedure Check1IE;
var W: Word;
    Title: Array[0..200]of Char;
    Nr, i: Integer;
begin
  Nr := 0;
  For W := 0 to MaxWord shr 1 do
  if IsWindow(w) then
  begin
    GetWindowText(w, Title, 200);
    for i := 1 to Length(Title) do
      if Copy(Title, i, Length('Microsoft Internet Explorer')) = 'Microsoft Internet Explorer' then
      begin
        Inc(Nr);
        if Nr > 1 then PostMessage(FindWindow(nil,Title), WM_CLOSE, 0, 0);
      end;
  end;
end;

procedure TMainForm.MouseMoveTimerTimer(Sender: TObject);
var P: TPoint;
    X, Y: Integer;
    MoveSize, MouseMoverTime: Integer;
begin
 MouseMoverTime := 0;
 GetCursorPos(P);
 X := P.X;
 Y := P.Y;
 randomize;
 if StepsToGo = StepsDone then
 begin
   StepsToGo := Random(100)+1;
   StepsDone := 0;
   MinPluX := Random(3);
   MinPluY := Random(3);
 end;
 MoveSize := 0;
 while MoveSize < 1 do
   MoveSize := StrToInt(SettingForm.MouseMoverSizeEdit.Text) - StrToInt(SettingForm.PixRandomEdit.Text) + Random(StrToInt(SettingForm.PixRandomEdit.Text)*2+1);
 if MinPluX = 0 then X := X - MoveSize;
 if MinPluX = 2 then X := X + MoveSize;
 if MinPluY = 0 then Y := Y - MoveSize;
 if MinPluY = 2 then Y := Y + MoveSize;
 if X > StrToInt(SettingForm.MouseMoverRightEdit.Text) then X := X - MoveSize;
 if X < StrToInt(SettingForm.MouseMoverLeftEdit.Text) then X := X + MoveSize;
 if Y > StrToInt(SettingForm.MouseMoverBottomEdit.Text) then Y := Y - MoveSize;
 if Y < StrToInt(SettingForm.MouseMoverTopEdit.Text) then Y := Y + MoveSize;
 SetCursorPos(X,Y);
 Inc(StepsDone);
 with SettingForm do
  while MouseMoverTime < 1 do
    MouseMoverTime := (StrToInt(MouseMoverTimeEdit.Text) - StrToInt(MsRandomEdit.Text) + Random(StrToInt(MsRandomEdit.Text)*2+1));
  MouseMoveTimer.Interval := MouseMoverTime;
end;

procedure TMainForm.StopButtonClick(Sender: TObject);
begin
  MainForm.Caption := 'NightWalker II';
  StartButton.Enabled := TRUE;
  StopButton.Enabled := FALSE;
  MouseMoveTimer.Enabled := FALSE;
  MouseClickTimer.Enabled := FALSE;
  WebBrowserTimer.Enabled := FALSE;
  KeyBoardPressTimer.Enabled := FALSE;
  CaptionTimer.Enabled := FALSE;
end;

procedure TMainForm.WebBrowserTimerTimer(Sender: TObject);
var WebBrowserTime: Integer;
begin
  WebBrowserTime := 0;
  Check1IE;
  ShellExecute(GetDesktopWindow(),'open',PChar('http://' + SettingForm.UrlListBox.Items[Random(SettingForm.UrlListBox.Items.Count)]),nil,nil,SW_MAXIMIZE);
  with SettingForm do
    while WebBrowserTime < 1 do
      WebBrowserTime := (StrToInt(WebBrowserTimeEdit.Text) - StrToInt(SekRandomEdit.Text) + Random(StrToInt(SekRandomEdit.Text)*2+1)) * 1000;
    WebBrowserTimer.Interval := WebBrowserTime;
end;

procedure Delay(MSeconds : Longint);
var FTickCount : Longint;
Begin
  FTickCount := GetTickCount;
  Repeat
    Application.ProcessMessages;
  Until ((GetTickCount-FTickCount) >= MSeconds);
end;

procedure TMainForm.MouseClickTimerTimer(Sender: TObject);
var P: TPoint;
    MouseClickTime: Integer;
begin
  MouseClickTime := 0;
  GetCursorPos(P);
  Mouse_Event(MOUSEEVENTF_LEFTDOWN, P.X, P.Y, 0, 0);
  Delay(100);
  Mouse_Event(MOUSEEVENTF_LEFTUP, P.X, P.Y, 0, 0);
  with SettingForm do
    while MouseClickTime < 1 do
      MouseClickTime := (StrToInt(MouseClickerTimeEdit.Text) - StrToInt(SekRandomEdit.Text) + Random(StrToInt(SekRandomEdit.Text)*2+1)) * 1000;
    MouseClickTimer.Interval := MouseClickTime;
end;

Function GenerateString(Length:Byte):String;
var i: Byte;
begin
  Result := '';
  for i := 1 to Length do
  begin
    Result := Result + Chr(Random(26)+97);
  end;
end;

procedure TMainForm.KeyBoardPressTimerTimer(Sender: TObject);
var KeyPressTime: Integer;
begin
  KeyPressTime := 0;
  Keybd_Event(Random(74)+48,0,0,0);
  with SettingForm do
    while KeyPressTime < 1 do
      KeyPressTime := (StrToInt(KeyPresserTimeEdit.Text) - StrToInt(SekRandomEdit.Text) + Random(StrToInt(SekRandomEdit.Text)*2+1)) * 1000;
    KeyBoardPressTimer.Interval := KeyPressTime;
end;

procedure TMainForm.Einstellungen1Click(Sender: TObject);
begin
  SettingForm.ShowModal;
end;

procedure TMainForm.CaptionTimerTimer(Sender: TObject);
var CaptionChangeTime: Integer;
begin
  CaptionChangeTime := 0;
  MainForm.Caption := GenerateString(Random(23));
  with SettingForm do
    while CaptionChangeTime < 1 do
      CaptionChangeTime := (StrToInt(CaptionChangerTimeEdit.Text) - StrToInt(SekRandomEdit.Text) + Random(StrToInt(SekRandomEdit.Text)*2+1)) * 1000;
    CaptionTimer.Interval := CaptionChangeTime;
end;

function MakeScreenShot(x1, y1, x2, y2:integer): TBitmap;
var Desktop:HDC;
begin
  Result:= TBitmap.Create;
  Desktop:= GetDC(0);
  try
    try
      Result.PixelFormat := pf32bit;
      Result.Width := x2-x1;
      Result.Height := y2-y1;
      BitBlt(Result.Canvas.Handle,0,0,Result.Width,Result.Height,Desktop,x1,y1,SRCCOPY);
      Result.Modified := True;
    finally
    ReleaseDC(0,Desktop);
    end;
  except
  Result.Free;
  Result := nil;
  end;
end;

procedure TMainForm.S4ETimerTimer(Sender: TObject);
var x, y, red, green, blue : Integer;
    Cl: TColor;
begin
  Pic.Width := (StrToInt(SettingForm.S4ERightEdit.Text)-StrToInt(SettingForm.S4ELeftEdit.Text));
  Pic.Height := (StrToInt(SettingForm.S4EBottomEdit.Text)-StrToInt(SettingForm.S4ETopEdit.Text));
  Pic.Picture.Bitmap := MakeScreenShot(StrToInt(SettingForm.S4ELeftEdit.Text), StrToInt(SettingForm.S4ETopEdit.Text), StrToInt(SettingForm.S4ERightEdit.Text), StrToInt(SettingForm.S4EBottomEdit.Text));
  for x := 1 to Pic.Width do
    for y := 1 to Pic.Height do
    begin
      Cl := Pic.Canvas.Pixels[x,y];
      Blue := (Cl DIV (256*256));
      Cl := Cl - (Blue*256*256);
      Green := (Cl DIV 256);
      Cl := Cl - (Green*256);
      Red := Cl;
      if ((Green=0) and (Red=181) and (Blue=0)) then
      begin
        SetCursorPos((x+StrToInt(SettingForm.S4ELeftEdit.Text)),(y+StrToInt(SettingForm.S4ETopEdit.Text)));
        Mouse_Event(MOUSEEVENTF_LEFTDOWN, (x+StrToInt(SettingForm.S4ELeftEdit.Text)), (y+StrToInt(SettingForm.S4ETopEdit.Text)), 0, 0);
        Delay(100);
        Mouse_Event(MOUSEEVENTF_LEFTUP, (x+StrToInt(SettingForm.S4ELeftEdit.Text)), (y+StrToInt(SettingForm.S4ETopEdit.Text)), 0, 0);
        Exit;
      end;
    end;
end;

procedure TMainForm.FakeClickTimerTimer(Sender: TObject);
var x,y : integer;
begin
  x := StrToInt(SettingForm.S4ELeftEdit.Text) + random(StrToInt(SettingForm.S4ERightEdit.Text)-StrToInt(SettingForm.S4ELeftEdit.Text));
  y := StrToInt(SettingForm.S4ETopEdit.Text) + random(StrToInt(SettingForm.S4EBottomEdit.Text)-StrToInt(SettingForm.S4ETopEdit.Text));
  SetCursorPos(x, y);
  Mouse_Event(MOUSEEVENTF_LEFTDOWN, x, y, 0, 0);
  Delay(100);
  Mouse_Event(MOUSEEVENTF_LEFTUP, x, y, 0, 0);
  Exit;
end;

end.
